make c-menu play/pause buttons into a toggle
February 26, 2017 23:46 - Liviu Andronic

Status: Rejected Start date: February 26, 2017
Priority: Minor Due date:
Description
Currently the systray c-menu has both a Play and a Pause button.
It would be neater if the two were combined into a single Play/Pause toggle, similarly to how this is already on the main toolbar.

History

#1 - March 06, 2017 15:19 - Liviu Andronic
- File Screenshot_2017-03-06_15-16-18.png added

I've just realized that this request would likely affect the Playback menu as well:
Screenshot_2017-03-06_15-16-18.png

Overall this would make all the playback menus / buttons more consistent with each other.

#2 - April 03, 2017 22:13 - Liviu Andronic
| should mention that right now, inadvertently it seems, hitting the Pause button twice will have essentially the same effect as a Play/Pause toggle.
If | were to tackle this feature myself, how should | approach it? | looked already at "ui_gtk.cc’ though it's not yet perfectly clear to me how the toggle

is being achieved there (there is only “button_play™ and no “button_pause’ there). And | looked at “statusicon.cc’, but it's not obvious to me how to the
Play and Pause buttons into a toggle...

#3 - April 03, 2017 22:39 - John Lindgren

Adding support for "dynamic" menus wouldn't be a good task for a new contributor since there will be some API design involved. If you're interested
in contributing in other areas, there are still some missing features in the Qt Ul that need to be ported. | would be thrilled to see pull requests for
some of those.
#4 - April 03, 2017 22:42 - John Lindgren

Liviu Andronic wrote:

| should mention that right now, inadvertently it seems, hitting the Pause button twice will have essentially the same effect as a Play/Pause
toggle.

That's intentional. The "Pause" command is really pause/unpause. And "Play" is not identical to unpause, so the two are not redundant.

#5 - April 05, 2017 22:34 - Liviu Andronic

John Lindgren wrote:

The "Pause" command is really pause/unpause. And "Play" is not identical to unpause, so the two are not redundant.

I think | understand now. From what | see, there are three possible 'initial' states:
- stopped

- playing

- paused

The current arrangement seems to work like this:

- Play will start playing the track from the beginning if 'stopped' or 'playing’, and resume playing the track if 'paused’
- Pause will pause the track if 'playing', resume playing the track if 'paused’, and do nothing if 'stopped’

- Stop will stop the track if 'playing' or 'paused', and do nothing if 'stopped'

For me the arrangement is still somewhat confusing, especially Pause acting as a Play/Pause toggle (with no dynamic icon change) and Pause being
available when 'stopped'.

In principle 'playing' and 'paused' are mutually exclusive states, which is why having a Play/Pause toggle would make sense. So the proposed
arrangement would work like this:

- Play will start playing the track from the beginning if 'stopped’, and resume playing the track if 'paused'

- Pause will pause the track if 'playing'

- Stop will stop the track if 'playing' or 'paused', and do nothing if 'stopped' (same as before)

Overall this seems to greatly simplify the logic of the Play/Pause arrangement and make it more intuitive. If the user wants to start the track from the

beginning when currently 'playing', we can reasonably expect them to first hit Stop then Play -- it seems like this would remain the only usecase that
wouldn't be covered directly by a single menu item.
#6 - April 14, 2020 14:51 - John Lindgren
- Status changed from New to Rejected

Closing feature requests that have not seen activity in over 3 years
